#!/usr/bin/python
# -*- coding: utf-8 -*-
#---------------------------------
import numpy as np
import matplotlib.pyplot as mpl
from importlib import reload
#---------------------------------
import modules.av_lib as av
reload(av)

dir_plots = "../plots/"
dir_data  = "../data/"
nfig = 0

# ficZ.tsv: champ de vecteurs 2D, z(x,y) = cos(xy) pour -pi <= (x,y) <= pi
# le fichier comprend un entete de deux lignes: xmin xmax xpas/ymin ymax ypas

Z, entete = av.lecture_tsv(dir_data+"ficZ.tsv",lignes_entete=2)

# extraction des extréma de x et y de l'entete
lx = entete[0].split()
ly = entete[1].split()
xmin, xmax, xpas = float(lx[0]), float(lx[1]), float(lx[2]) 
ymin, ymax, ypas = float(ly[0]), float(ly[1]), float(ly[2]) 

x = np.arange(xmin,xmax+xpas/2,xpas)
y = np.arange(ymin,ymax+ypas/2,ypas)

X,Y = np.meshgrid(x,y)

# Création d'un champ de vecteurs: (U, V) = gradient(Z)
U, V = -Y*np.sin(X*Y), -X*np.sin(X*Y)

# tracé du champ z(x,y) et des champs de vecteurs U, V
nfig += 1
fname = dir_plots + "cossin.png"

av.contour(nfig,X,Y,Z,filled=False, titre="Un champ scalaire et son gradient",
           labX='X',labY='Y')

av.plot_vecteurs(nfig,X,Y,U,V,ndecim=3,hold=True)# ,figure_name=fname)

# tracé 3D du champ z(x,y)
nfig += 1
fname = dir_plots + "surf3D.png"
av.surf3D(nfig,X,Y,Z,titre="le champs Z en 3D",labX="X",labY="Y",labZ="Z")
          #figure_name=fname)

